-- Turbine Imports..

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

--import d'un des scripts

import "Galphoglas.LotroChannFilter.ColorPicker.ColorPicker";

Turbine.Shell.WriteLine("Chargement en cours");

----------------------------
-- Variables Principales
----------------------------
version="1.1.0"

listecanal={"UserChat1","UserChat2","UserChat3","UserChat4","UserChat5","UserChat6","UserChat7","UserChat8","Fellowship","Kinship","Tell","Trade","Emote","EnemyCombat","Error","OOC","Roleplay","PlayerCombat","World","Death","Officer","Say","Advancement","Quest","Raid","LFF","Regional","Tribe"};
tradcanal={"Chat Utilisateur 1","Chat Utilisateur 2","Chat Utilisateur 3","Chat Utilisateur 4","Chat Utilisateur 5","Chat Utilisateur 6","Chat Utilisateur 7","Chat Utilisateur 8","Communauté","Confrérie","Dire","Echanger","Emote","Ennemi en combat","Erreur","HDP","JDR","Joueur en combat","Monde","Mort","Officier","Parler","Progression","Quête","Raid","RDC","Régional","Tribu"};
----------------------------
-- Premiere utilisation
----------------------------

gauche = 200;
haut = 200;
couleur = {};
for i=1,28
do
	couleur[i]=Turbine.UI.Color(1,1,1);
end
listeBan={"Pay.com"}

filtreSpam=false;
DelaisSpam=5;
AntiSpamActive=false;
Memoire={};
Memoire[1]={};
Memoire[1].Message="Premier Message";
Memoire[1].Temps=0;
Memoire[2]={};
Memoire[2].Message="Deuxieme Message";
Memoire[2].Temps=0;
k=1;

Pause=false;

----------------------------------
-- Fenetre des parametres
----------------------------------

lcf = Turbine.UI.Lotro.Window();

lcf:SetSize(500,500);
lcf:SetPosition(gauche,haut);
lcf:SetText("Canaux à filtrer");
lcf:SetVisible(false);

-- Chexkbox

lcf.Check = Turbine.UI.Lotro.CheckBox();
lcf.Color = Turbine.UI.Window();
for i=1,28
do
py=60+22*i;
	if py<390 then
		lcf.Check[listecanal[i]] = Turbine.UI.Lotro.CheckBox();
		lcf.Check[listecanal[i]]:SetParent(lcf);
		lcf.Check[listecanal[i]]:SetText(tradcanal[i]);
		lcf.Check[listecanal[i]]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		lcf.Check[listecanal[i]]:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
		lcf.Check[listecanal[i]]:SetSize(150, 20);
		lcf.Check[listecanal[i]]:SetPosition(60, py);
		lcf.Check[listecanal[i]]:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		lcf.Check[listecanal[i]].MouseEnter = function()
			if lcf.Check[listecanal[i]]:IsChecked() then
				info("ok");
			else
				info("nok");
			end
		end
		lcf.Check[listecanal[i]].MouseLeave = function()
			info(0);
		end
		
		lcf.Color[listecanal[i]] =Turbine.UI.Window();
		lcf.Color[listecanal[i]]:SetSize(18,18);
		lcf.Color[listecanal[i]]:SetPosition(221, py+1);
		lcf.Color[listecanal[i]]:SetBackColor(couleur[i]);
		lcf.Color[listecanal[i]]:SetParent(lcf);
		lcf.Color[listecanal[i]]:SetVisible(true);
		lcf.Color[listecanal[i]].MouseClick = function()
			cp:SetVisible(true);
			lcf.app:SetVisible(false);
			cp.LeftClick= function ()
				lcf.Color[listecanal[i]]:SetBackColor(cp.GetTurbineColor());
				cp:SetVisible(false);
				lcf.app:SetVisible(true);
				info(0);
			end
		end
		lcf.Color[listecanal[i]].MouseEnter = function()
			info("color");
		end
		lcf.Color[listecanal[i]].MouseLeave = function()
			info(0);
		end
		
	else
	
	
		lcf.Check[listecanal[i]] = Turbine.UI.Lotro.CheckBox();
		lcf.Check[listecanal[i]]:SetParent(lcf);
		lcf.Check[listecanal[i]]:SetText(tradcanal[i]);
		lcf.Check[listecanal[i]]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		lcf.Check[listecanal[i]]:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
		lcf.Check[listecanal[i]]:SetSize(150, 20);
		lcf.Check[listecanal[i]]:SetPosition(260, py-308);
		lcf.Check[listecanal[i]]:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		lcf.Check[listecanal[i]].MouseEnter = function()
			if lcf.Check[listecanal[i]]:IsChecked() then
				info("ok");
			else
				info("nok");
			end
		end
		lcf.Check[listecanal[i]].MouseLeave = function()
			info(0);
		end
		
		lcf.Color[listecanal[i]] =Turbine.UI.Window();
		lcf.Color[listecanal[i]]:SetSize(18,18);
		lcf.Color[listecanal[i]]:SetPosition(421, py-307);
		lcf.Color[listecanal[i]]:SetBackColor(couleur[i]);
		lcf.Color[listecanal[i]]:SetParent(lcf);
		lcf.Color[listecanal[i]]:SetVisible(true);
		lcf.Color[listecanal[i]].MouseClick = function()
			cp:SetVisible(true);
			lcf.app:SetVisible(false);
			cp.LeftClick= function ()
				lcf.Color[listecanal[i]]:SetBackColor(cp.GetTurbineColor());				
				cp:SetVisible(false);
				lcf.app:SetVisible(true);
				info(0);
			end
		end
		lcf.Color[listecanal[i]].MouseEnter = function()
			info("color");
		end
		lcf.Color[listecanal[i]].MouseLeave = function()
			info(0);
		end
	end
	--Pour ceux qui nécéssite la poubelle
	if i<=8 or i==12 or i==16 or i==17 or i==19 or i==26 or i==27 then
		lcf.Check[listecanal[i]]:SetForeColor(Turbine.UI.Color(1, 1, 1));
	end
end

-- Selecteur de couleur

cp = ColorPicker.ColorPicker.Create();
cp:SetParent(lcf);
cp:SetSize(450,70);
cp:SetPosition(25,400);
cp:SetVisible(false);
cp.RightClick=function()
	cp:SetVisible(false);
	lcf.app:SetVisible(true);
	info(0);
end
cp.MouseEnter = function()
	info("cpinfo");
end

-- Horodateur
-- Se lance dans le charge settings

function SelecteurHoro()
	listehoro={"Aucun horodateur","aaaa/mm/jj hh:mm:ss","aaaa/mm/jj hh:mm","jj/mm/aaaa hh:mm:ss","jj/mm/aaaa hh:mm","mm/jj hh:mm:ss","mm/jj hh:mm","jj/mm hh:mm:ss","jj/mm hh:mm","hh:mm:ss","hh:mm"};
	lcf.horo = DropDown.Create(listehoro,valhoro);
	lcf.horo:SetParent(lcf);
	lcf.horo:ApplyWidth(175); 
	lcf.horo:SetMaxItems(6); 
	lcf.horo:SetPosition(60,40);
	lcf.horo:SetVisible(true);
end
	
-- Button

lcf.mot = Turbine.UI.Lotro.Button();
lcf.mot:SetParent(lcf);
lcf.mot:SetPosition(250, 40);
lcf.mot:SetSize(200, 20);
lcf.mot:SetText("Liste des mots a filtrer");
lcf.mot:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
lcf.mot.Click = function()
	lcf:SetVisible(false);
	listeMotsBan();
end
lcf.mot.MouseEnter = function()
		info("motban");
	end
lcf.mot.MouseLeave =function()
		info(0);
end

lcf.app = Turbine.UI.Lotro.Button();
lcf.app:SetParent(lcf);
lcf.app:SetPosition(150, 425);
lcf.app:SetSize(200, 20);
lcf.app:SetText("Appliquer définitivement");
lcf.app:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
lcf.app.Click = function()
	saveSettings();
	lcf:SetVisible(false);
	lcfliste:SetVisible(false);
end
lcf.app.MouseEnter = function()
		info("appliquer");
	end
lcf.app.MouseLeave =function()
		info(0);
end

-- Sauvegarde des parametres

function saveSettings()
	
	settings={};--para géné
	settings.Gauche=lcf:GetLeft();
	settings.Haut=lcf:GetTop();
	settings.Horo=lcf.horo:GetText();
	
	settingsColor={};--para couleur
	settingsMot={};--para couleur
	
	for i=1,28
	do
		settings[listecanal[i]]=lcf.Check[listecanal[i]]:IsChecked();--regarde check
	
		settingsColor[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();--regarde color
	
		color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();
		settingsColor[listecanal[i]].R=(color[listecanal[i]].R)*10000;--pour corriger le probleme de compréhension de la virgule dans les plugindata
		settingsColor[listecanal[i]].G=(color[listecanal[i]].G)*10000;
		settingsColor[listecanal[i]].B=(color[listecanal[i]].B)*10000;
	
	end
	
	Turbine.PluginData.Save(Turbine.DataScope.Character, "lcf", settings);--save check
	Turbine.PluginData.Save(Turbine.DataScope.Character, "lcfColor", settingsColor);--save color
	
end

-- Récupération

function chargeSetting()

	--chargement check+position
	settings=Turbine.PluginData.Load(Turbine.DataScope.Character, "lcf");
	if settings==nil then
		settings={}
	else
		gauche=settings.Gauche;
		haut=settings.Haut;
		lcf:SetPosition(gauche,haut);
		valhoro="Aucun horodateur";
		valhoro=settings.Horo;
		for i=1,28
		do
			lcf.Check[listecanal[i]]:SetChecked(settings[listecanal[i]]);
		end
	end
	
	--chargement color
	settingsColor=Turbine.PluginData.Load(Turbine.DataScope.Character, "lcfColor");
	if settingsColor==nil then
		settingsColor={}
	else
		for i=1,28
		do
			lcf.Color[listecanal[i]]:SetBackColor(Turbine.UI.Color(settingsColor[listecanal[i]].R/10000,settingsColor[listecanal[i]].G/10000,settingsColor[listecanal[i]].B/10000));--pour corriger le probleme de compréhension de la virgule dans les plugindata
		end
	end

	--chargement mot
	chargeMots();
	
	-- Horodateur ajouter ici car impossible de le faire mettre a jour autrement
	SelecteurHoro(valhoro);
	
end

------------------
-- Commandes
------------------

LCFCommand = Turbine.ShellCommand();

function LCFCommand:Execute(cmd, args)
	if (args == "visible") then
		lcf:SetVisible(true);
	elseif (args == "raz") then
		RaZ();
	elseif (args == "pause") then
		if (Pause==true) then
			Turbine.Shell.WriteLine("Pause déjà activée !");
			Turbine.Shell.WriteLine("Pour réactiver la recopie des messages, tapez /lcf reprise.");
		else
			Pause=true;
			Turbine.Shell.WriteLine("C'est la pause ! Plus aucun message recopié");
			Turbine.Shell.WriteLine("Pour réactiver la recopie des messages, tapez /lcf reprise.");
		end
	elseif (args == "reprise") then
		if (Pause==false) then
			Turbine.Shell.WriteLine("Recopie des messages activé !");
			Turbine.Shell.WriteLine("Pour l'arreter, tapez /lcf pause");
		else
			Pause=false;
			Turbine.Shell.WriteLine("Fin de la pause ! Reprise de la recopie des messages.");
		end
	else
		LCFCommand:GetHelp();
	end
end

function LCFCommand:GetHelp()
	Turbine.Shell.WriteLine("Lotro Chann Filter version ".. version);
	Turbine.Shell.WriteLine("Nom anglais, mais fait par un français !");
	Turbine.Shell.WriteLine("Filtre de canal. Mais pas que !");
	Turbine.Shell.WriteLine("");
	Turbine.Shell.WriteLine("Commandes d'affichage: /lcf visible");
	Turbine.Shell.WriteLine("Commandes de RAZ: /lcf raz (Ne concerne pas la liste des mots et retour en arrière impossible!)");
	Turbine.Shell.WriteLine("");
	Turbine.Shell.WriteLine("Besoin d'une pause? Intéropez la recopie");
	Turbine.Shell.WriteLine("    Arret de la recopie des messages /lcf pause");
	Turbine.Shell.WriteLine("    Reprise de la recopie des messages /lcf reprise");
end


---------------------------
-- Fonction de travail
---------------------------


function AddCallback(object, event, callback, color)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function chatHandler(sender, args)

	color={};
	flag=0;
	flagSpam=false;

	if (Pause==false) then		
		for i=1,28
		do
			 if (args.ChatType == Turbine.ChatType[listecanal[i]] and lcf.Check[listecanal[i]]:IsChecked()) then --On regarde si le filtre correspondant est activer a chaque nouveau message sur un canal
				Message = string.lower(args.Message) -- on enleve toutes les majuscules pour etre sur de la comparaison
				j=1;
				while j<=table.getn(listeBan)
				do
					if string.match(Message, string.lower(listeBan[j])) then --On regarde si le mot est dans la liste
						flag=1;
					end
					j=j+1;
				end
				if (flag==0) then --Si le mot n'est pas dans la liste on lvérifie si c'est un spam
					if (AntiSpamActive==true) then					
						for l=1, table.getn(Memoire)
							do					
							if (Memoire[l].Message==Message) then
								if (Memoire[l].Temps+DelaisSpam>=Turbine.Engine.GetGameTime()) then
									flagSpam=true;
								else
									Memoire[l].Temps=Turbine.Engine.GetGameTime();
									color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();-- On récupère la couleur
									Turbine.Shell.WriteLine("<rgb=#"..tostring(DEC_HEX(math.floor(255*color[listecanal[i]].R))..DEC_HEX(math.floor(255*color[listecanal[i]].G))..DEC_HEX(math.floor(255*color[listecanal[i]].B)))..">"..Horodateur()..args.Message);-- on écrit le tout :p
									flagSpam=true;
								end
							end
						end					
						if (flagSpam==true) then 
							flagSpam=false;
						else
							Memoire[k]={};
							Memoire[k].Message=Message;
							Memoire[k].Temps=Turbine.Engine.GetGameTime();
							k=k+1;
							color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();-- On récupère la couleur
							Turbine.Shell.WriteLine("<rgb=#"..tostring(DEC_HEX(math.floor(255*color[listecanal[i]].R))..DEC_HEX(math.floor(255*color[listecanal[i]].G))..DEC_HEX(math.floor(255*color[listecanal[i]].B)))..">"..Horodateur()..args.Message);-- on écrit le tout :p
						end
					else
						color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();-- On récupère la couleur
						Turbine.Shell.WriteLine("<rgb=#"..tostring(DEC_HEX(math.floor(255*color[listecanal[i]].R))..DEC_HEX(math.floor(255*color[listecanal[i]].G))..DEC_HEX(math.floor(255*color[listecanal[i]].B)))..">"..Horodateur()..args.Message);-- on écrit le tout :p
					end
				end
				flag=0;
			end
		end
	end
	
end

function DEC_HEX(IN) --Fonction crée par Gahulad présente dans le colorpicker déjà repris ici
		local B,K,OUT,I,D=16,"0123456789ABCDEF","",0
			if IN == 0 then return "00" end;
			while IN>0 do
			I=I+1
			IN,D=math.floor(IN/B),math.mod(IN,B)+1
			OUT=string.sub(K,D,D)..OUT
		end
		if string.len(OUT) == 1 then OUT = "0" .. OUT end;
		return OUT
	end

-----------------
-- Horodateur
-----------------

function Horodateur()
	an=Turbine.Engine.GetDate().Year;
	mo=Turbine.Engine.GetDate().Month;
	jo=Turbine.Engine.GetDate().Day;

	he=Turbine.Engine.GetDate().Hour;
	mi=Turbine.Engine.GetDate().Minute;
	se=Turbine.Engine.GetDate().Second;
	
	if an<10 then an="0"..an end
	if mo<10 then mo="0"..mo end
	if jo<10 then jo="0"..jo end
	
	if he<10 then he="0"..he end
	if mi<10 then mi="0"..mi end
	if se<10 then se="0"..se end
	
	if (lcf.horo:GetText()=="aaaa/mm/jj hh:mm:ss") then horo= "["..an.."/"..mo.."/"..jo..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()=="aaaa/mm/jj hh:mm") then horo= "["..an.."/"..mo.."/"..jo..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()=="jj/mm/aaaa hh:mm:ss") then horo= "["..jo.."/"..mo.."/"..an..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()=="jj/mm/aaaa hh:mm") then horo= "["..jo.."/"..mo.."/"..an..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()=="mm/jj hh:mm:ss") then horo= "["..mo.."/"..jo..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()=="mm/jj hh:mm") then horo= "["..mo.."/"..jo..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()=="jj/mm hh:mm:ss") then horo= "["..jo.."/"..mo..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()=="jj/mm hh:mm") then horo= "["..jo.."/"..mo..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()=="hh:mm:ss") then horo= "["..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()=="hh:mm") then horo= "["..he..":"..mi.."] "
	else horo="" end
	
	return horo;
		
end

---------------
-- AntiSpam
---------------

function Delais()
	if valIntervalleSpam=="5 sec" then DelaisSpam=5;
	elseif valIntervalleSpam=="10 sec" then DelaisSpam=10;
	elseif valIntervalleSpam=="15 sec" then DelaisSpam=15;
	elseif valIntervalleSpam=="20 sec" then DelaisSpam=20;
	elseif valIntervalleSpam=="25 sec" then DelaisSpam=25;
	elseif valIntervalleSpam=="30 sec" then DelaisSpam=30;
	elseif valIntervalleSpam=="35 sec" then DelaisSpam=35;
	elseif valIntervalleSpam=="40 sec" then DelaisSpam=40;
	elseif valIntervalleSpam=="45 sec" then DelaisSpam=45;
	elseif valIntervalleSpam=="50 sec" then DelaisSpam=50;
	elseif valIntervalleSpam=="55 sec" then DelaisSpam=55;
	elseif valIntervalleSpam=="1 min" then DelaisSpam=60;
	elseif valIntervalleSpam=="1 min 30" then DelaisSpam=90;
	elseif valIntervalleSpam=="2 min" then DelaisSpam=120;
	elseif valIntervalleSpam=="2 min 30" then DelaisSpam=150;
	elseif valIntervalleSpam=="3 min" then DelaisSpam=180;
	elseif valIntervalleSpam=="3 min 30" then DelaisSpam=210;
	elseif valIntervalleSpam=="4 min" then DelaisSpam=240;
	elseif valIntervalleSpam=="4 min 30" then DelaisSpam=270;
	elseif valIntervalleSpam=="5 min" then DelaisSpam=300;
	end
	
	return DelaisSpam;
end


-------------------
-- Construction
-------------------

-- Importations des scripts

import "Galphoglas.LotroChannFilter.DropDown";
import "Galphoglas.LotroChannFilter.mots";
import "Galphoglas.LotroChannFilter.confirmation";
import "Galphoglas.LotroChannFilter.information";

-- Chargement des parametres

chargeSetting();

-- Mise en place des commandes

AddCallback(Turbine.Chat, "Received", chatHandler, color);
Turbine.Shell.AddCommand("lcf", LCFCommand);

-- Confirmation de réussite de l'opération

Turbine.Shell.WriteLine("Filtre lancé!");
Turbine.Shell.WriteLine("Tapez /lcf pour plus d'info");